Index: /trunk/src/sh_hash.c
===================================================================
--- /trunk/src/sh_hash.c	(revision 584)
+++ /trunk/src/sh_hash.c	(revision 1)
@@ -741,64 +988,227 @@
 void sh_hash_init ()
 {
-  volatile int  retval  = 0;
-  volatile int  exitval = EXIT_SUCCESS;
+  sh_file_t * p;
+  SL_TICKET fd    = (-1);
+  long i;
+  int count = 0;
+  char * line = NULL;
+
+#if defined(WITH_GPG) || defined(WITH_PGP)
+  extern int get_the_fd (SL_TICKET ticket);
+  FILE *   fin_cp;
+
+  char * buf  = NULL;
+  int    bufc;
+  int    flag_pgp = S_FALSE;
+  int    flag_nohead = S_FALSE;
+  SL_TICKET fdTmp = (-1);
+  SL_TICKET open_tmp (void);
+#endif
 
   SL_ENTER(_("sh_hash_init"));
 
-  if ( sh.flag.checkSum == SH_CHECK_INIT )
-    {
-      dlog(1, FIL__, __LINE__, 
-	   _("Attempt to load the baseline database during initialisation. This is an internal error, please report it to the developer.\n"));
-      SH_ABORT;
+  if (IsInit == 1) 
+    SL_RET0(_("sh_hash_init"));
+
+  for (i = 0; i < TABSIZE; ++i) 
+    tab[i] = NULL;
+
+#if defined(SH_WITH_CLIENT)
+
+  /* Data file from Server
+   */
+
+  if (fd == (-1) && 0 == sl_strcmp(file_path('D', 'R'), _("REQ_FROM_SERVER")))
+    {
+      sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_D_DSTART);
+      fd = sh_forward_req_file(_("DATA"));
+      if (SL_ISERROR(fd))
+	{
+	  dlog(1, FIL__, __LINE__, 
+	       _("Could not retrieve the file signature database from the server(errnum = %ld).\nPossible reasons include:\n - the server is not running,\n - session key negotiation failed (see the manual for proper setup), or\n - the server cannot access the file.\n"), fd); 
+	  sh_error_handle ((-1), FIL__, __LINE__, fd, MSG_EXIT_ABORT1, 
+			   sh.prg_name);
+	  aud_exit (FIL__, __LINE__, EXIT_FAILURE);
+	}
+      sl_rewind (fd);
+
+      tiger_fd = fd;
+      sl_strlcpy (sh.data.hash, 
+		  sh_tiger_hash (file_path('C', 'R'), /*irrelevant, TIGER_FD*/ 
+				 TIGER_FD, 0),
+		  KEY_LEN+1);
+      sl_rewind (fd);
+    }
+  else 
+#endif
+    /* Local data file
+     */
+
+    if (fd == (-1))
+      {
+	if ( SL_ISERROR(fd = sl_open_read(file_path('D', 'R'), SL_YESPRIV))) 
+	  {
+	    TPT(( 0, FIL__, __LINE__, _("msg=<Error opening: %s>\n"), 
+		  file_path('D', 'R')));
+	    dlog(1, FIL__, __LINE__, 
+		 _("Could not open the local file signature database for reading because\nof the following error: %s (errnum = %ld)\nIf this is a permission problem, you need to change file permissions\nto make the file readable for the effective UID: %d\n"), 
+		 sl_get_errmsg(), fd, (int) sl_ret_euid());
+	    sh_error_handle ((-1), FIL__, __LINE__, fd, MSG_EXIT_ABORT1, 
+			     sh.prg_name);
+	    aud_exit (FIL__, __LINE__, EXIT_FAILURE);
+	  }
+	
+	TPT(( 0, FIL__, __LINE__, _("msg=<Opened database: %s>\n"), 
+	      file_path('D', 'R')));
+
+	tiger_fd = fd;
+	if (0 != sl_strncmp(sh.data.hash, 
+			    sh_tiger_hash (file_path('D', 'R'), TIGER_FD, 0),
+			    KEY_LEN)
+	    && sh.flag.checkSum != SH_CHECK_INIT) 
+	  {
+	    dlog(1, FIL__, __LINE__, 
+		 _("The checksum of the file signature database has changed since startup.\n"));
+	    sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_AUTH,
+			     ( (NULL == file_path('D', 'R')) ? _("(null)") :
+			       file_path('D', 'R') )
+			     );
+	    aud_exit (FIL__, __LINE__, EXIT_FAILURE);
+	  }
+	sl_rewind (fd);
+
+      } /* new 1.4.8 */
+
+  if (sig_termfast == 1)  /* SIGTERM */
+    {
+      TPT((0, FIL__, __LINE__, _("msg=<Terminate.>\n")));
+      --sig_raised; --sig_urgent;
+      aud_exit (FIL__, __LINE__, EXIT_SUCCESS);
+    }
+
+#if defined(WITH_GPG) || defined(WITH_PGP)
+  /* new 1.4.8: also checked for server data */
+
+  /* extract the data and copy to temporary file
+   */
+  fdTmp = open_tmp();
+
+  fin_cp = fdopen(get_the_fd(fd), "rb");
+  buf = (char *) SH_ALLOC(8192);
+
+
+  /* while ( (bufc = sh_unix_getline (fd, buf, 8191)) > 0) */
+  while (NULL != fgets(buf, 8192, fin_cp))
+    {
+      bufc = 0; 
+      while (bufc < 8192) { 
+	if (buf[bufc] == '\n') { ++bufc; break; }
+	++bufc;
+      }
+
+      if (sig_termfast == 1)  /* SIGTERM */
+	{
+	  TPT((0, FIL__, __LINE__, _("msg=<Terminate.>\n")));
+	  --sig_raised; --sig_urgent;
+	  aud_exit (FIL__, __LINE__, EXIT_SUCCESS);
+	}
+
+      if (flag_pgp == S_FALSE &&
+	  (0 == sl_strcmp(buf, _("-----BEGIN PGP SIGNED MESSAGE-----\n"))||
+	   0 == sl_strcmp(buf, _("-----BEGIN PGP MESSAGE-----\n")))
+	  )
+	{
+	  flag_pgp = S_TRUE;
+	  sl_write(fdTmp, buf, bufc);
+	  continue;
+	}
+      
+      if (flag_pgp == S_TRUE && flag_nohead == S_FALSE)
+	{
+	  if (buf[0] == '\n')
+	    {
+	      flag_nohead = S_TRUE;
+	      sl_write(fdTmp, buf, 1);
+	      continue;
+	    }
+	  else if (0 == sl_strncmp(buf, _("Hash:"), 5) ||
+		   0 == sl_strncmp(buf, _("NotDashEscaped:"), 15))
+	    {
+	      sl_write(fdTmp, buf, bufc);
+	      continue;
+	    }
+	  else
+	    continue;
+	}
+    
+      if (flag_pgp == S_TRUE && buf[0] == '\n')
+	{
+	  sl_write(fdTmp, buf, 1);
+	}
+      else if (flag_pgp == S_TRUE)
+	{
+	  /* sl_write_line(fdTmp, buf, bufc); */
+	  sl_write(fdTmp, buf, bufc);
+	}
+      
+      if (flag_pgp == S_TRUE && 
+	  0 == sl_strcmp(buf, _("-----END PGP SIGNATURE-----\n")))
+	break;
+    }
+  SH_FREE(buf);
+  sl_close(fd);
+  fclose(fin_cp);
+
+  fd = fdTmp;
+  sl_rewind (fd);
+
+  /* Validate signature of open file.
+   */
+  if (0 != sh_gpg_check_sign (0, fd, 2))
+    {
       aud_exit (FIL__, __LINE__, EXIT_FAILURE);
     }
-
-  SH_MUTEX_LOCK(mutex_hash);
-
-  if (IsInit == 1)
-    { 
-      goto unlock_and_return;
-    }
-
-  /* Initialization completed.
+  sl_rewind (fd);
+#endif
+  /* } new 1.4.8 check sig also for files downloaded from server */
+
+  line = SH_ALLOC(MAX_PATH_STORE+1);
+
+  /* fast forward to start of data
    */
-  retval = sh_dbIO_load_db(tab);
-
-  if (0 == retval)
-    IsInit = 1;
-  else
-    exitval = EXIT_FAILURE;
-
- unlock_and_return:
-  ; /* 'label at end of compound statement */
-  SH_MUTEX_UNLOCK(mutex_hash);
-  if (retval == 0)
-    {
-      SL_RET0(_("sh_hash_init"));
-    }
-  sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_EXIT_ABORT1, sh.prg_name);
-  aud_exit (FIL__, __LINE__, exitval);
-}
-
-void sh_hash_init_and_checksum()
-{
-  TPT((0, FIL__, __LINE__, _("msg=<Get checksum of the database.>\n")))
-  if (sh.flag.checkSum == SH_CHECK_CHECK) 
-    {
-      if (0 != sl_strcmp(file_path('D', 'R'), _("REQ_FROM_SERVER")))
-	{
-	  char hashbuf[KEYBUF_SIZE];
-	  (void) sl_strlcpy(sh.data.hash,
-			    sh_tiger_hash (file_path('D', 'R'), 
-					   TIGER_FILE, TIGER_NOLIM, 
-					   hashbuf, sizeof(hashbuf)), 
-			    KEY_LEN+1);
-	}
-
-      /* this eventually fetches the file from server to get checksum
-       */
-      sh_hash_init ();
-    }
-  return;
+  sh_hash_setdataent(fd, line, MAX_PATH_STORE, file_path('D', 'R'));
+
+  while (1) 
+    {
+      if (sig_termfast == 1)  /* SIGTERM */
+	{
+	  TPT((0, FIL__, __LINE__, _("msg=<Terminate.>\n")));
+	  --sig_raised; --sig_urgent;
+	  aud_exit (FIL__, __LINE__, EXIT_SUCCESS);
+	}
+
+      p = sh_hash_getdataent (fd, line, MAX_PATH_STORE);
+      if (p != NULL)
+	{
+	  hashinsert (p); 
+	  ++count;
+	}
+      else
+	break;
+    }
+
+  if (line != NULL)
+    SH_FREE(line);
+
+  /* Always keep db in memory, so we have no open file
+   */
+  sl_close (fd);
+  sh_hash_getline_end();
+  fd = -1;
+
+  /* --- Initialization done successfully. ---
+   */
+  IsInit = 1;
+  SL_RET0(_("sh_hash_init"));
 }
   
@@ -814,11 +1224,6 @@
   SL_ENTER(_("sh_hash_hashdelete"));
 
-  /* need deadlock detection here if called from exit handler 
-   */
-  SH_MUTEX_TRYLOCK(mutex_hash);
-
   if (IsInit == 0) 
-    goto unlock_and_exit;
-
+    SL_RET0(_("sh_hash_hashdelete"));
   for (i = 0; i < TABSIZE; ++i) 
     if (tab[i] != NULL)
@@ -828,20 +1233,459 @@
       }
   IsInit = 0;
-
- unlock_and_exit:
-  ; /* 'label at end of compound statement */
-  SH_MUTEX_TRYLOCK_UNLOCK(mutex_hash);
-
   SL_RET0(_("sh_hash_hashdelete"));
 }
 
-static int sh_loosedircheck = S_FALSE;
-
-int sh_hash_loosedircheck(const char * str)
-{
-  return sh_util_flagval(str, &sh_loosedircheck);
-}
-
-
+/******************************************************************
+ *
+ * Insert a file into the database.
+ *
+ ******************************************************************/ 
+static int       pushdata_isfirst =  1;
+static SL_TICKET pushdata_fd      = -1;
+
+static int       pushdata_stdout  =  S_FALSE;
+
+static char * sh_db_version_string = NULL;
+
+int sh_hash_pushdata_stdout (char * str)
+{
+  if (!str)
+    { pushdata_stdout  =  S_TRUE; return 0; }
+  return -1;
+}
+
+int sh_hash_version_string(char * str)
+{
+  int i;
+  if (str)
+    {
+      i = sl_strlen(str);
+      if (sh_db_version_string != NULL) {
+	SH_FREE(sh_db_version_string);
+      }
+      if (0 == sl_strncmp(str, _("NULL"), 4))
+	{
+	  sh_db_version_string = NULL;
+	  return 0;
+	}
+      sh_db_version_string = SH_ALLOC(i+1);
+      sl_strlcpy(sh_db_version_string, str, i+1);
+      return 0;
+    }
+  return -1;
+}
+
+#if 0
+void sh_hash_pushdata_reset ()
+{
+  if (!SL_ISERROR(pushdata_fd))
+    {
+      sl_close(pushdata_fd);
+      pushdata_fd = -1;
+    }
+  pushdata_isfirst =  1;
+}
+#endif
+
+void sh_hash_pushdata (file_type * buf, char * fileHash)
+{
+  static long p_count = 0;
+
+  int         status = 0;
+
+  char      * tmp;
+  size_t      tmp_len = 0;
+  size_t      old_len = 0;
+
+  sh_filestore_t p;
+
+  struct stat sbuf;
+
+  char *  fullpath = NULL;
+  char *  linkpath = NULL;
+
+  char * line = NULL;
+
+  char   timestring[81];
+  char * timep;
+
+#if !defined(__linux__)
+  int    i;
+#endif
+
+  SL_ENTER(_("sh_hash_pushdata"));
+
+  fullpath = SH_ALLOC(MAX_PATH_STORE+1);
+  linkpath = SH_ALLOC(MAX_PATH_STORE+1);
+
+  linkpath[0] =  '-'; 
+  linkpath[1] = '\0'; 
+  fullpath[0] =  '-'; 
+  fullpath[1] = '\0';
+
+  if (!buf) {
+    memset(&p, '\0', sizeof(sh_filestore_t));
+  }
+
+  if ((pushdata_stdout == S_TRUE) && (sh.flag.update == S_TRUE))
+    {
+      dlog(1, FIL__, __LINE__, 
+	   _("You cannot write the database to stdout when you use update rather than init.\n"));
+      sh_error_handle((-1), FIL__, __LINE__, 0, MSG_EXIT_ABORTS,
+		      _("Writing database to stdout with update"), 
+		      sh.prg_name, 
+		      _("sh_hash_pushdata"));
+      aud_exit(FIL__, __LINE__, EXIT_FAILURE);
+    }
+
+  if ((pushdata_stdout == S_TRUE) && (sl_is_suid()))
+    {
+      dlog(1, FIL__, __LINE__, 
+	   _("You cannot write the database to stdout when running with suid privileges.\n"));
+      sh_error_handle((-1), FIL__, __LINE__, 0, MSG_EXIT_ABORTS,
+		      _("Writing database to stdout when suid"), 
+		      sh.prg_name, 
+		      _("sh_hash_pushdata"));
+      aud_exit(FIL__, __LINE__, EXIT_FAILURE);
+    }
+
+
+  if ((pushdata_stdout == S_FALSE) && 
+      ( (NULL == file_path('D', 'W')) || 
+	(0 == sl_strcmp(file_path('D', 'W'), _("REQ_FROM_SERVER"))) ))
+    {
+      dlog(1, FIL__, __LINE__, 
+	   _("You need to configure a local path for initializing the database\nlike ./configure --with-data-file=REQ_FROM_SERVER/some/local/path\n"));
+      sh_error_handle((-1), FIL__, __LINE__, 0, MSG_EXIT_ABORTS,
+		      _("No local path for database specified"), 
+		      sh.prg_name, 
+		      _("sh_hash_pushdata"));
+      aud_exit(FIL__, __LINE__, EXIT_FAILURE);
+    }
+
+
+  if ((pushdata_stdout == S_FALSE) && (pushdata_isfirst == 1))  
+    {
+      /* Warn that file already exists; file_path != NULL here because
+       * checked above
+       */
+      if (0 == retry_lstat(FIL__, __LINE__, file_path('D', 'W'), &sbuf))
+	{
+	  if (sh.flag.update == S_FALSE)
+	    {
+	      sh_error_handle((-1), FIL__, __LINE__, 0, MSG_FI_DBEX,
+			      file_path('D', 'W'));
+	    }
+	}
+    }
+
+
+  if (sh.flag.update == S_FALSE)
+    {
+      if (pushdata_stdout == S_FALSE)
+	{
+	  pushdata_fd = -1;
+	  if ( SL_ISERROR(pushdata_fd = sl_open_write(file_path('D', 'W'), SL_YESPRIV))) {
+	    SH_FREE(fullpath);
+	    SH_FREE(linkpath);
+	    sh_error_handle((-1), FIL__, __LINE__, pushdata_fd, MSG_E_ACCESS,
+			    geteuid(), file_path('D', 'W'));
+	    SL_RET0(_("sh_hash_pushdata"));
+	  }
+	  if ( SL_ISERROR(status = sl_forward(pushdata_fd))) {
+	    SH_FREE(fullpath);
+	    SH_FREE(linkpath);
+	    sh_error_handle((-1), FIL__, __LINE__, status, MSG_E_SUBGPATH,
+			    _("Fast forward failed"), _("sh_hash_pushdata"),
+			    file_path('D', 'W'));
+	    SL_RET0(_("sh_hash_pushdata"));
+	  }
+	}
+    }
+  else /* update == TRUE */
+    {
+      if (pushdata_isfirst == 1)
+	{
+	  TPT((0, FIL__, __LINE__, _("msg=<Update.>\n")))
+	  if ( SL_ISERROR(pushdata_fd = sl_open_rdwr(file_path('D', 'W'), SL_YESPRIV))){
+	    SH_FREE(fullpath);
+	    SH_FREE(linkpath);
+	    sh_error_handle((-1), FIL__, __LINE__, pushdata_fd, MSG_E_ACCESS,
+			    geteuid(), file_path('D', 'W'));
+	    SL_RET0(_("sh_hash_pushdata"));
+	  }
+	  line = SH_ALLOC(MAX_PATH_STORE+1);
+	  if (SL_ISERROR(sh_hash_setdataent_old (pushdata_fd, line, 
+						 MAX_PATH_STORE, 
+						 file_path('D', 'W'))))
+	    {
+	      SH_FREE(fullpath);
+	      SH_FREE(linkpath);
+	      SH_FREE(line);
+	      SL_RET0(_("sh_hash_pushdata"));
+	    }
+	  SH_FREE(line);
+	}
+    }
+	 
+  if (buf != NULL && buf->fullpath != NULL) {
+
+    old_len = sl_strlen(buf->fullpath);
+#if defined(SH_STEALTH)
+    sh_do_encode(buf->fullpath, old_len);
+#endif
+    tmp = quote_string(buf->fullpath);
+    tmp_len = sl_strlen(tmp);
+#if defined(SH_STEALTH)
+    sh_do_decode(buf->fullpath, old_len);
+#endif
+
+    if (tmp_len <= MAX_PATH_STORE) 
+      {
+	sl_strlcpy(fullpath, buf->fullpath, MAX_PATH_STORE+1);
+	/*
+	if (sl_strlen(buf->fullpath) < (MAX_PATH_STORE-3))
+	  {
+	    fullpath[MAX_PATH_STORE-2] = '\0';
+	    fullpath[MAX_PATH_STORE-1] = '\n';
+	  }
+	*/
+      } 
+    else 
+      {
+	sl_strlcpy(fullpath, 
+		   sh_tiger_hash (buf->fullpath,
+				  TIGER_DATA, old_len), 
+		   KEY_LEN+1);
+      }
+    SH_FREE(tmp);
+  }
+
+#if defined(SH_STEALTH)
+  sh_do_encode(fullpath, sl_strlen(fullpath));
+#endif
+
+  tmp = quote_string(fullpath);
+  sl_strlcpy(fullpath, tmp, MAX_PATH_STORE+1);
+  SH_FREE(tmp);
+
+  if (buf != NULL && buf->c_mode[0] == 'l' && buf->linkpath != NULL) 
+    {  
+
+      old_len = sl_strlen(buf->linkpath);
+#if defined(SH_STEALTH)
+      sh_do_encode(buf->linkpath, old_len);
+#endif
+      tmp = quote_string(buf->linkpath);
+      tmp_len = sl_strlen(tmp);
+#if defined(SH_STEALTH)
+      sh_do_decode(buf->linkpath, old_len);
+#endif
+
+      if (tmp_len <= MAX_PATH_STORE) 
+	{
+	  sl_strlcpy(linkpath, buf->linkpath, MAX_PATH_STORE+1);  
+	} 
+      else 
+	{
+	  sl_strlcpy(linkpath, 
+		     sh_tiger_hash (buf->linkpath,
+				    TIGER_DATA, old_len),
+		     KEY_LEN+1);
+	}
+      SH_FREE(tmp);
+
+#if defined(SH_STEALTH)
+      sh_do_encode(linkpath, sl_strlen(linkpath));
+#endif
+      tmp = quote_string(linkpath);
+      sl_strlcpy(linkpath, tmp, MAX_PATH_STORE+1);
+      SH_FREE(tmp);
+    }
+
+  if (buf != NULL) {
+    p.mark = REC_MAGIC;
+    sl_strlcpy(p.c_mode,   buf->c_mode,   11);
+    sl_strlcpy(p.c_group,  buf->c_group,  GROUP_MAX+1);
+    sl_strlcpy(p.c_owner,  buf->c_owner,  USER_MAX+1);
+    if (fileHash) {
+      sl_strlcpy(p.checksum, fileHash,      KEY_LEN+1);
+    }
+#if defined(__linux__)
+    sl_strlcpy(p.c_attributes, buf->c_attributes, 13);
+#else
+    for (i = 0; i < 12; ++i) p.c_attributes[i] = '-';
+    p.c_attributes[12] = '\0';
+#endif
+    
+#if defined(SH_STEALTH)
+    sh_do_encode(p.c_mode,   sl_strlen(p.c_mode));
+    sh_do_encode(p.c_owner,  sl_strlen(p.c_owner));
+    sh_do_encode(p.c_group,  sl_strlen(p.c_group));
+    sh_do_encode(p.checksum, sl_strlen(p.checksum));
+
+    sh_do_encode(p.c_attributes,   sl_strlen(p.c_attributes));
+#endif
+    
+#if defined(__linux__)
+    p.attributes  = (UINT32) buf->attributes;
+#else
+    p.attributes  = 0;
+#endif
+    p.linkmode    = (UINT32) buf->linkmode;
+    p.hardlinks   = (UINT32) buf->hardlinks;
+    p.dev   = (UINT64) buf->dev;
+    p.rdev  = (UINT64) buf->rdev;
+    p.mode  = (UINT32) buf->mode;
+    p.ino   = (UINT32) buf->ino;
+    p.size  = (UINT64) buf->size;
+    p.mtime = (UINT64) buf->mtime;
+    p.atime = (UINT64) buf->atime;
+    p.ctime = (UINT64) buf->ctime;
+    p.owner = (UINT32) buf->owner;
+    p.group = (UINT32) buf->group;
+    
+    swap_32(&(p.mode));
+    swap_32(&(p.linkmode));
+    swap_64(&(p.dev));
+    swap_64(&(p.rdev));
+    swap_32(&(p.hardlinks));
+    swap_32(&(p.ino));
+    swap_64(&(p.size));
+    swap_64(&(p.atime));
+    swap_64(&(p.mtime));
+    swap_64(&(p.ctime));
+    swap_32(&(p.owner));
+    swap_32(&(p.group));
+    swap_32(&(p.attributes));
+
+#ifdef OLD_BUG
+    swap_short(&(p.mark));
+#else
+    p.mark = *(swap_short(&(p.mark)));
+#endif
+  }
+
+  /* write the start marker 
+   */
+  if (pushdata_isfirst == 1) 
+    {
+      if (sh.flag.update == S_FALSE)
+	{
+	  if (sh_db_version_string != NULL)
+	    {
+	      if (pushdata_stdout == S_FALSE)
+		{
+		  sl_write (pushdata_fd, _("\n#Host "), 7);
+		  sl_write (pushdata_fd, sh.host.name, 
+			    sl_strlen(sh.host.name));
+		  sl_write (pushdata_fd, _(" Version "), 9);
+		  sl_write (pushdata_fd, sh_db_version_string, 
+			    sl_strlen(sh_db_version_string));
+		  sl_write (pushdata_fd, _(" Date "), 6);
+		  timep = sh_unix_time(0);
+		  sl_strlcpy(timestring, timep, sizeof(timestring));
+		  sl_write (pushdata_fd, timestring, sl_strlen(timestring));
+		  sl_write (pushdata_fd,        "\n", 1);
+		} else {
+		  printf (_("\n#Host "));
+		  printf ("%s", sh.host.name);
+		  printf (_(" Version "));
+		  printf ("%s", sh_db_version_string);
+		  printf (_(" Date "));
+		  timep = sh_unix_time(0);
+		  sl_strlcpy(timestring, timep, sizeof(timestring));
+		  printf ("%s\n", timestring);
+		}
+	    }
+
+	  if (pushdata_stdout == S_FALSE)
+	    {
+#if defined(SH_STEALTH)
+	      sl_write      (pushdata_fd,        "\n", 1);
+	      sl_write_line (pushdata_fd, N_("[SOF]"), 5);
+#else
+	      sl_write_line (pushdata_fd, _("\n[SOF]"),  6);
+#endif
+	    }
+	  else 
+	    {
+#if defined(SH_STEALTH)
+	      printf ("\n%s\n", N_("[SOF]"));
+#else
+	      printf ("%s\n", _("\n[SOF]"));
+#endif
+	    }
+	}
+      pushdata_isfirst = 0;
+    }
+      
+  if (pushdata_stdout == S_FALSE)
+    {
+      sl_write      (pushdata_fd,       &p, sizeof(sh_filestore_t));
+      sl_write_line (pushdata_fd, fullpath,    sl_strlen(fullpath));
+      sl_write_line (pushdata_fd, linkpath,    sl_strlen(linkpath));
+    } else {
+      fwrite (&p, sizeof(sh_filestore_t), 1, stdout);
+      printf ("%s\n", fullpath);
+      printf ("%s\n", linkpath);
+    }
+
+  ++p_count;
+
+  if ((sh.flag.update != S_TRUE) && (pushdata_stdout == S_FALSE))
+    {
+      sl_close (pushdata_fd);
+      pushdata_fd = -1;
+    }
+
+  SH_FREE(fullpath);
+  SH_FREE(linkpath);
+
+  SL_RET0(_("sh_hash_pushdata"));
+}
+
+int sh_hash_writeout()
+{
+  sh_file_t * p;
+  int         i;
+  file_type * f;
+  char   fileHash[KEY_LEN + 1];
+
+  SL_ENTER(_("sh_hash_writeout"));
+
+  if (S_TRUE == file_is_remote())
+    {
+      sh_error_handle((-1), FIL__, __LINE__, S_FALSE, MSG_E_SUBGEN, 
+		      _("Baseline database is remote"), _("sh_hash_writeout"));
+      SL_RETURN (1, _("sh_hash_writeout"));
+    }
+
+  if (!SL_ISERROR(pushdata_fd))
+    {
+      sl_close(pushdata_fd);
+      pushdata_fd = -1;
+    }
+  pushdata_isfirst =  1;
+
+  for (i = 0; i < TABSIZE; ++i)
+    {
+      for (p = tab[i]; p; p = p->next)
+	{
+	  f = sh_hash_create_ft (p, fileHash);
+	  sh_hash_pushdata (f, fileHash);
+	  SH_FREE(f);
+	}
+    }
+
+  if (!SL_ISERROR(pushdata_fd))
+    {
+      sl_close(pushdata_fd);
+      pushdata_fd = -1;
+    }
+  pushdata_isfirst =  1;
+
+  SL_RETURN (0, _("sh_hash_writeout"));
+}
 
 
@@ -851,176 +1695,55 @@
  *
  *********************************************************************/
-static sh_file_t *  sh_hash_have_it_int (const char * newname)
+static sh_file_t *  sh_hash_have_it_int (char * newname)
 {
   sh_file_t * p;
-  char hashbuf[KEYBUF_SIZE];
-
-  SL_ENTER(_("sh_hash_have_it_int"));
+
+  SL_ENTER(_("sh_hash_have_it"));
 
   if (newname == NULL)
-    SL_RETURN( (NULL), _("sh_hash_have_it_int"));
-
+    SL_RETURN( (NULL), _("sh_hash_have_it"));
+
+  if (IsInit != 1) 
+    sh_hash_init();
   if (sl_strlen(newname) <= MAX_PATH_STORE) 
     p = hashsearch(newname);
   else 
-    p = hashsearch ( sh_tiger_hash(newname, TIGER_DATA, sl_strlen(newname),
-				   hashbuf, sizeof(hashbuf)) );
+    p = hashsearch ( sh_tiger_hash(newname, TIGER_DATA, sl_strlen(newname)) );
   if (p == NULL) 
-     SL_RETURN( (NULL), _("sh_hash_have_it_int"));
-
-  SL_RETURN( (p), _("sh_hash_have_it_int"));
-}
-
-int sh_hash_have_it (const char * newname)
-{
-  sh_file_t * p;
-  int retval;
-
-  if (IsInit != 1) 
-    sh_hash_init();
-
-  SH_MUTEX_LOCK(mutex_hash);
-
-  retval = 0;
-
-  p = sh_hash_have_it_int (newname);
-
-  if (!p) 
-    retval = (-1);
-  else if ((!SH_FFLAG_ALLIGNORE_SET(p->fflags)) && 
-	   (p->modi_mask & MODI_CHK) != 0 &&
-	   (p->modi_mask & MODI_MOD) != 0)
-    retval = 1;
-  SH_MUTEX_UNLOCK(mutex_hash);
-
-  return retval;
-}
-
-int sh_hash_get_it (const char * newname, file_type * tmpFile, char * fileHash)
-{
-  sh_file_t * p;
-  int retval;
-
-  if (IsInit != 1) 
-    sh_hash_init();
-
-  tmpFile->link_path   = NULL;
-  tmpFile->attr_string = NULL;
-
-  SH_MUTEX_LOCK(mutex_hash);
-
-  retval = (-1);
-
-  p = sh_hash_have_it_int (newname);
-  if (p)
-    {
-      sl_strlcpy(tmpFile->fullpath,  p->fullpath, PATH_MAX);
-      if (p->linkpath)
-	tmpFile->link_path = sh_util_strdup (p->linkpath);
-      tmpFile->size  = p->theFile.size;
-      tmpFile->mtime = p->theFile.mtime;
-      tmpFile->ctime = p->theFile.ctime;
-      tmpFile->atime = p->theFile.atime;
-
-      if (NULL != fileHash)
-	sl_strlcpy(fileHash, p->theFile.checksum, KEY_LEN+1);
-
-      tmpFile->attr_string = NULL;
-      retval = 0;
-    }
-  SH_MUTEX_UNLOCK(mutex_hash);
-
-  return retval;
-}
-
-int sh_hash_getflags (char * filename)
-{
-  sh_file_t * p;
-  int retval = 0;
-
-  if ( sh.flag.checkSum != SH_CHECK_INIT )
-    {
-      if (IsInit != 1) 
-	sh_hash_init();
-      
-      SH_MUTEX_LOCK(mutex_hash);
-      p = sh_hash_have_it_int (filename);
-      if (p)
-	retval = p->fflags;
-      else
-	retval = -1;
-      SH_MUTEX_UNLOCK(mutex_hash);
-    }
-  return retval;
-}
-
-int sh_hash_setflags (char * filename, int flags)
-{
-  sh_file_t * p;
-  int retval = 0;
-
-  if ( sh.flag.checkSum != SH_CHECK_INIT )
-    {
-      if (IsInit != 1) 
-	sh_hash_init();
-      
-      SH_MUTEX_LOCK(mutex_hash);
-      p = sh_hash_have_it_int (filename);
-      if (p)
-	{
-	  p->fflags = flags;
-	  retval = 0;
-	}
-      else
-	retval = -1;
-      SH_MUTEX_UNLOCK(mutex_hash);
-    }
-  return retval;
-}
-
-/* needs lock to be threadsafe
- */
-void sh_hash_set_flag (char * filename, int flag_to_set)
-{
-  sh_file_t * p;
-
-  if ( sh.flag.checkSum != SH_CHECK_INIT )
-    {
-      if (IsInit != 1) 
-	sh_hash_init();
-      
-      SH_MUTEX_LOCK(mutex_hash);
-      p = sh_hash_have_it_int (filename);
-      if (p)
-	{
-	  p->fflags |= flag_to_set;
-	}
-      SH_MUTEX_UNLOCK(mutex_hash);
-    }
-  return;
-}
-
-/* needs lock to be threadsafe
- */
-void sh_hash_clear_flag (char * filename, int flag_to_clear)
-{
-  sh_file_t * p;
-
-  if ( sh.flag.checkSum != SH_CHECK_INIT )
-    {
-      if (IsInit != 1) 
-	sh_hash_init();
-      
-      SH_MUTEX_LOCK(mutex_hash);
-      p = sh_hash_have_it_int (filename);
-      if (p)
-	{
-	  p->fflags &= ~flag_to_clear;
-	}
-      SH_MUTEX_UNLOCK(mutex_hash);
-    }
-  return;
-}
-
+     SL_RETURN( (NULL), _("sh_hash_have_it"));
+  /*
+  if (p->allignore == S_FALSE && 
+      (p->modi_mask & MODI_CHK) != 0 &&
+      (p->modi_mask & MODI_MOD) != 0)
+    SL_RETURN( (1), _("sh_hash_have_it"));
+  */
+  SL_RETURN( (p), _("sh_hash_have_it"));
+}
+
+int sh_hash_have_it (char * newname)
+{
+  sh_file_t * p = sh_hash_have_it_int (newname);
+
+  if (!p) return (-1);
+  if (p->allignore == S_FALSE && 
+      (p->modi_mask & MODI_CHK) != 0 &&
+      (p->modi_mask & MODI_MOD) != 0)
+    return 1;
+  return 0;
+}
+
+int sh_hash_get_it (char * newname, file_type * tmpFile)
+{
+  sh_file_t * p = sh_hash_have_it_int (newname);
+  if (!p)
+    return (-1);
+  sl_strlcpy(tmpFile->fullpath, p->fullpath, PATH_MAX);
+  sl_strlcpy(tmpFile->linkpath, p->linkpath, PATH_MAX);
+  tmpFile->size  = p->theFile.size;
+  tmpFile->mtime = p->theFile.mtime;
+  tmpFile->ctime = p->theFile.ctime;
+  return 0;
+}
+ 
 
 /*****************************************************************
@@ -1034,6 +1757,4 @@
 {
   sh_file_t * p;
-  char hashbuf[KEYBUF_SIZE];
-  int  retval;
 
   SL_ENTER(_("sh_hash_set_visited_int"));
@@ -1041,40 +1762,25 @@
   if (newname == NULL)
     SL_RETURN((-1), _("sh_hash_set_visited_int"));
-
   if (IsInit != 1) 
     sh_hash_init();
-
-  SH_MUTEX_LOCK(mutex_hash);
 
   if (sl_strlen(newname) <= MAX_PATH_STORE) 
     p = hashsearch(newname);
   else 
-    p = hashsearch (sh_tiger_hash(newname, TIGER_DATA, sl_strlen(newname),
-				  hashbuf, sizeof(hashbuf)));
+    p = hashsearch (sh_tiger_hash(newname, TIGER_DATA, sl_strlen(newname)));
   
-  if (p)
-    {
-      if (flag == SH_FFLAG_CHECKED)
-	{
-	  CLEAR_SH_FFLAG_REPORTED(p->fflags);
-	  CLEAR_SH_FFLAG_VISITED(p->fflags);
-	  SET_SH_FFLAG_CHECKED(p->fflags);
-	}
-      else
-	{
-	  SET_SH_FFLAG_VISITED(p->fflags);
-	  CLEAR_SH_FFLAG_CHECKED(p->fflags);
-	  if (flag == SH_FFLAG_REPORTED)
-	    SET_SH_FFLAG_REPORTED(p->fflags);
-	  else
-	    CLEAR_SH_FFLAG_REPORTED(p->fflags);
-	}
-      retval = 0;
-    }
-  else
-    retval = -1;
-
-  SH_MUTEX_UNLOCK(mutex_hash);
-  SL_RETURN((retval), _("sh_hash_set_visited_int"));
+  if (p == NULL) 
+    SL_RETURN((-1), _("sh_hash_set_visited_int"));
+  if (flag == 99)
+    {
+      p->visited  = 99;
+      p->reported = S_FALSE;
+    }
+  else
+    {
+      p->visited  = S_TRUE;
+      p->reported = flag;
+    }
+  SL_RETURN((0), _("sh_hash_set_visited_int"));
 }
 
@@ -1085,33 +1791,22 @@
 {
   int i;
-  SL_ENTER(_("sh_hash_set_missing"));
-
-  i = sh_hash_set_visited_int(newname, SH_FFLAG_CHECKED);
-
-  if (sh.flag.checkSum != SH_CHECK_INIT) {
-    sh_hash_remove(newname);
-  }
-
-  SL_RETURN(i, _("sh_hash_set_missing"));
-}
-
-/* mark the file as visited and reported
- */
+  SL_ENTER(_("sh_hash_set_visited"));
+  i = sh_hash_set_visited_int(newname, 99);
+  SL_RETURN(i, _("sh_hash_set_visited"));
+}
+
 int sh_hash_set_visited (char * newname)
 {
   int i;
   SL_ENTER(_("sh_hash_set_visited"));
-  i = sh_hash_set_visited_int(newname, SH_FFLAG_REPORTED);
+  i = sh_hash_set_visited_int(newname, S_TRUE);
   SL_RETURN(i, _("sh_hash_set_visited"));
 }
 
-/* mark the file as visited and NOT reported
- * used to avoid deletion of file from internal database
- */
 int sh_hash_set_visited_true (char * newname)
 {
   int i;
   SL_ENTER(_("sh_hash_set_visited_true"));
-  i = sh_hash_set_visited_int(newname, 0);
+  i = sh_hash_set_visited_int(newname, S_FALSE);
   SL_RETURN(i, _("sh_hash_set_visited_true"));
 }
@@ -1124,66 +1819,76 @@
  ******************************************************************/
 
-void sh_hash_push2db (const char * key, struct store2db * save)
-{
+static char * sh_hash_charhex( unsigned char i )
+{
+  static char i2h[2];
+  int j, k;
+
+  j = i / 16;
+  k = i - (j*16);
+
+  if (j < 10) i2h[0] = '0'+j;
+  else        i2h[0] = 'A'+(j-10);
+  
+  if (k < 10) i2h[1] = '0'+k;
+  else        i2h[1] = 'A'+(k-10);
+
+  return i2h;
+}
+
+void sh_hash_push2db (char * key, unsigned long val1, 
+		      unsigned long val2, unsigned long val3,
+		      unsigned char * str, int size)
+{
+  file_type   tmpFile;
   int         i = 0;
   char      * p;
-  char        i2h[2];
-  file_type * tmpFile = SH_ALLOC(sizeof(file_type));
-
-  int size            = save->size;
-  unsigned char * str = save->str;
-
-
-  tmpFile->attr_string = NULL;
-  tmpFile->link_path   = NULL;
-
-  sl_strlcpy(tmpFile->fullpath, key, PATH_MAX);
-  tmpFile->size  = save->val0;
-  tmpFile->mtime = save->val1;
-  tmpFile->ctime = save->val2;
-  tmpFile->atime = save->val3;
-
-  tmpFile->mode  = 0;
-  tmpFile->owner = 0;
-  tmpFile->group = 0;
-  sl_strlcpy(tmpFile->c_owner, _("root"), 5);
-  sl_strlcpy(tmpFile->c_group, _("root"), 5);
-
-  tmpFile->check_flags = 0;
+
+  sl_strlcpy(tmpFile.fullpath, key, PATH_MAX);
+  tmpFile.size  = val1;
+  tmpFile.mtime = val2;
+  tmpFile.ctime = val3;
+
+  tmpFile.atime = 0;
+  tmpFile.mode  = 0;
+  tmpFile.owner = 0;
+  tmpFile.group = 0;
+  sl_strlcpy(tmpFile.c_owner, _("root"), 5);
+  sl_strlcpy(tmpFile.c_group, _("root"), 5);
 
   if ((str != NULL) && (size < (PATH_MAX/2)-1))
     {
-      tmpFile->c_mode[0] = 'l';  
-      tmpFile->c_mode[1] = 'r'; tmpFile->c_mode[2]  = 'w';
-      tmpFile->c_mode[3] = 'x'; tmpFile->c_mode[4]  = 'r'; 
-      tmpFile->c_mode[5] = 'w'; tmpFile->c_mode[6]  = 'x'; 
-      tmpFile->c_mode[7] = 'r'; tmpFile->c_mode[8]  = 'w'; 
-      tmpFile->c_mode[9] = 'x'; tmpFile->c_mode[10] = '\0';
-      tmpFile->link_path = SH_ALLOC((size * 2) + 2);
+      tmpFile.c_mode[0] = 'l';  
+      tmpFile.c_mode[1] = 'r'; tmpFile.c_mode[2]  = 'w';
+      tmpFile.c_mode[3] = 'x'; tmpFile.c_mode[4]  = 'r'; 
+      tmpFile.c_mode[5] = 'w'; tmpFile.c_mode[6]  = 'x'; 
+      tmpFile.c_mode[7] = 'r'; tmpFile.c_mode[8]  = 'w'; 
+      tmpFile.c_mode[9] = 'x'; tmpFile.c_mode[10] = '\0'; 
       for (i = 0; i < size; ++i)
 	{
-	  p = sh_util_charhex (str[i],i2h);
-	  tmpFile->link_path[2*i]   = p[0];
-	  tmpFile->link_path[2*i+1] = p[1];
-	  tmpFile->link_path[2*i+2] = '\0';
-	}
-    }
-  else
-    {
-      for (i = 0; i < 10; ++i) 
-	tmpFile->c_mode[i] = '-';
-      tmpFile->c_mode[10] = '\0';
-      tmpFile->link_path = sh_util_strdup("-");
-    }
-
-  if (sh.flag.checkSum == SH_CHECK_INIT)
-    sh_dbIO_data_write (tmpFile, 
-			(save->checksum[0] == '\0') ? SH_KEY_NULL : save->checksum);
-  else
-    sh_hash_pushdata_memory (tmpFile, 
-			     (save->checksum[0] == '\0') ? SH_KEY_NULL : save->checksum);
-
-  if (tmpFile->link_path) SH_FREE(tmpFile->link_path);
-  SH_FREE(tmpFile);
+	  p = sh_hash_charhex (str[i]);
+	  tmpFile.linkpath[2*i]   = p[0];
+	  tmpFile.linkpath[2*i+1] = p[1];
+	  tmpFile.linkpath[2*i+2] = '\0';
+	}
+    }
+  else
+    {
+      tmpFile.c_mode[0] = '-';  
+      tmpFile.c_mode[1] = '-'; tmpFile.c_mode[2]  = '-';
+      tmpFile.c_mode[3] = '-'; tmpFile.c_mode[4]  = '-'; 
+      tmpFile.c_mode[5] = '-'; tmpFile.c_mode[6]  = '-'; 
+      tmpFile.c_mode[7] = '-'; tmpFile.c_mode[8]  = '-'; 
+      tmpFile.c_mode[9] = '-'; tmpFile.c_mode[10] = '\0'; 
+      tmpFile.linkpath[0] = '-'; tmpFile.linkpath[1] = '\0';
+    }
+
+  if (sh.flag.checkSum == SH_CHECK_CHECK && 
+      sh.flag.update == S_TRUE)
+    sh_hash_pushdata_memory (&tmpFile, 
+			     _("000000000000000000000000000000000000000000000000"));
+  else
+    sh_hash_pushdata (&tmpFile, 
+		      _("000000000000000000000000000000000000000000000000"));
+
   return;
 }
